#include <stdio.h>
#include <math.h>
#include <imsls.h>

int main()
{
 
   char *col_labels[] = {" ", "\nID", "\nDF", "\nSSQ", 
      "Mean\nsquares", "\nF", "\np-value"};
   char **anova_row_labels = NULL;
   int i, j, k, l, page_width = 132;
   int n = 24;                
   int n_locations = 1;       
   int n_strip_a   = 2;       
   int n_strip_b   = 4;       
 
   int block[]={
      1, 1, 1, 1, 1, 1, 1, 1,
      2, 2, 2, 2, 2, 2, 2, 2,
      3, 3, 3, 3, 3, 3, 3, 3};
   int strip_a[]={
      1, 1, 1, 1, 2, 2, 2, 2, 
      1, 1, 1, 1, 2, 2, 2, 2,
      1, 1, 1, 1, 2, 2, 2, 2};
   int strip_b[]={
      1, 2, 3, 4, 1, 2, 3, 4, 
      1, 2, 3, 4, 1, 2, 3, 4,  
      1, 2, 3, 4, 1, 2, 3, 4};
   float y[] ={
      30.0, 40.0, 38.9, 38.2,
      41.8, 52.2, 54.8, 58.2,
      20.5, 26.9, 21.4, 25.1,
      26.4, 36.7, 28.9, 35.9,
      21.0, 25.4, 24.0, 23.3,
      34.4, 41.0, 33.0, 34.9};
   float grand_mean=0;
   float *cv, *aov, *treatment_means;
   float *strip_plot_a_means, *strip_plot_b_means;
   float *std_err;
   int   n_missing, *equal_means;
 
   aov = imsls_f_strip_plot(n, n_locations, n_strip_a, n_strip_b, 
      block, strip_a, strip_b, y, 
      IMSLS_GRAND_MEAN, &grand_mean, 
      IMSLS_CV, &cv,
      IMSLS_N_MISSING,  &n_missing,  
      IMSLS_STRIP_PLOT_A_MEANS, &strip_plot_a_means, 
      IMSLS_STRIP_PLOT_B_MEANS, &strip_plot_b_means, 
      IMSLS_TREATMENT_MEANS, &treatment_means,
      IMSLS_STD_ERRORS,  &std_err,
      IMSLS_ANOVA_ROW_LABELS, &anova_row_labels,
      0);
 
   /* Output results. */
   imsls_page(IMSLS_SET_PAGE_WIDTH, &page_width);
 
   /* Print ANOVA table. */
   imsls_f_write_matrix("   *** ANALYSIS OF VARIANCE TABLE ***", 
      12, 6, aov, 
      IMSLS_WRITE_FORMAT, "%3.0f%3.0f%8.2f%7.2f%7.2f%7.3f",
      IMSLS_ROW_LABELS, anova_row_labels,
      IMSLS_COL_LABELS, col_labels,
      0);
 
   printf("\nGrand mean: %f\n", grand_mean);
 
   /* Print treatment means */
   imsls_f_write_matrix("Treatment Means", n_strip_a, n_strip_b,
      treatment_means, 0);
   printf("\n\nStandard Error for Comparing Two Treatment Means: \n");
   printf("  Same Level of Factor B          %f (df=%f)\n",
      std_err[2], std_err[7]);
   printf("  Same Level of Factor A          %f (df=%f)\n",
      std_err[3], std_err[8]);
   printf("  Different Factor A and B Levels %f (df=%f)\n\n\n\n",
      std_err[4], std_err[9]);
 
 
   /* Print factor A means */
   imsls_f_write_matrix("Factor A Means", n_strip_a, 1, 
      strip_plot_a_means, 0);
   printf("\nStandard Error for Comparing Two Factor A Means: \n");
   printf("%f (df=%f)\n", std_err[0], std_err[5]);
   equal_means = imsls_f_multiple_comparisons(n_strip_a, 
      strip_plot_a_means, (int) std_err[5], std_err[0]/sqrt(2), 
      IMSLS_LSD,
      IMSLS_ALPHA, .05,
      0);
   /* Print multiple comparison results */
   imsls_i_write_matrix("LSD Comparison : Size of Groups of Means", 
      1, n_strip_a-1,  equal_means, 0);
 
 
   /* Print factor B means */
   imsls_f_write_matrix("\n\nFactor B Means", n_strip_b, 1,
      strip_plot_b_means, 0);
   printf("\nStandard Error for Comparing Two Factor B Means: \n");
   printf("%f (df=%f)\n", std_err[1], std_err[6]);
   equal_means = imsls_f_multiple_comparisons(n_strip_b, 
      strip_plot_b_means, (int)std_err[6], std_err[1]/sqrt(2), 
      IMSLS_LSD,
      IMSLS_ALPHA, .05,
      0);
   /* Multiple comparison results */
   imsls_i_write_matrix("LSD Comparison : Size of Groups of Means", 
      1, n_strip_b-1, equal_means, 0);
}
